********************
********************
**
**   Source File ... SOS_DEMO.PRG
**
**   Application ... SOS Help! v1.25b
**                   Copyright (c) 1988-92 Lamaura Development Limited
**                   All Rights Reserved
**
**   Author ........ Philip de Lisle
**   Last Update ... 20 October 1992 at 1:25am
**   Purpose ....... Demo Program
**
********************
********************


//
// MUST be compiled with /n switch
//

//
// Uses SetHelpVars() found in ALT_FUNC.PRG
//

#include 'inkey.ch'
#include 'sos_help.ch'


STATIC saASCII := {}        // static array used in TBrowseDemo()
STATIC snTBrowseRow := 1    // Holds TBrowse Row Counter for TBrowseDemo()
STATIC snAchoiceLen := 0    // Holds Length of ACHOICE array item for AddHelp()

FUNCTION SOS_Demo
**
** Syntax ..... SOS_DEMO()
**
** Purpose .... Activate SOS Help! Demo
**
** Argument ... None
**
** Returns .... Nothing
**

LOCAL i, nMenuItem := 0, cScreen, cWords

//
// Preload static array used by TBrowseDemo()
//
cWords := 'NULSOHSTXETXEOTENQACKBELBS HT LF VT FF CR SO SI DLEDC1DC2DC3' + ;
          'DC4NAKSYNETBCANEM SUBESCFS GS RS US ';

FOR i := 0 TO 255
    AADD(saASCII, nil)
    saASCII[i+1] := STR(i,4) + ' ' + IIF(i<16, '0', '') + Hex(i) + ' ' + ;
                     CHR(i) + ' '

    IF i < 32
       IF i = 0
          saASCII[i+1] := STRTRAN(saASCII[i+1], CHR(0), ' ')
       ENDIF

       saASCII[i+1] := saASCII[i+1] + '^' + IIF(i = 0, '@', CHR(i+64)) + ;
                         ' ' + SUBSTR(cWords, (i*3)+1, 3)
    ENDIF
    saASCII[i+1] := PAD(saASCII[i+1], 17)
NEXT

*SET DATE BRITISH
SET SCOREBOARD OFF
SET CURSOR OFF
SETCANCEL(.f.)
SET EXCLUSIVE OFF

IF (.NOT. OpenHelp('DemoHelp', 250, '+w/r, n/w', .f.)) .AND. ;
    (SOS_Library() <> SOS_BINARY)
  ?? CHR(7)
  @ 23,0 SAY 'Cannot Open SOS Help! Help Database'
  WAIT
ENDIF

SET COLOR TO N/W
@ 0,0,24,79 BOX REPLICATE(CHR(178), 9)

SET COLOR TO +W/BG
@ 0,0,3,28 BOX "         "
@ 0, 4 SAY "SOS Help! v1.25b Demo"
@ 1, 4 SAY "Copyright (c) 1991-2"
@ 2, 1 SAY "Lamaura Development Limited"
@ 3, 3 SAY "(Author: Phil de Lisle)"

//
//  paint the commentary box
//
SET COLOR TO +W/G
@ 05,25,22,78 BOX "ͻȺ"
@ 22,44 SAY " Commentary Box "
SET COLOR TO N/W
@ 06,26,21,77 BOX "         "
@ 07,28 SAY "Welcome to the Demo of SOS Help! v1.25b - the"
@ 08,28 SAY "complete Help Design System for Clipper."
@ 10,28 SAY "This is an interactive demo. The MENU TO .. Demo"
@ 11,28 SAY "to the left of this box is a standard Clipper"
@ 12,28 SAY "menu using @..PROMPTs and the MENU TO command."
@ 13,28 SAY "Press <F1> now to bring up the Help Design"
@ 14,28 SAY "System (if it does not appear you have forgotten"
@ 15,28 SAY "to SET HELP!=.T. at the DOS prompt)."
@ 17,28 SAY "Select each menu item in turn and press <F1> to"
@ 18,28 SAY "see SOS Help! in action. Then study the demo"
@ 19,28 SAY "source code provided to see how easy it is to"
@ 20,28 SAY "add context-sensitive help to your applications."

cScreen := SAVESCREEN(05,23,24,78)

DO WHILE .T.
   //
   //  paint the menu
   //
   SET COLOR TO +W/B
   @ 06,02,14,20 BOX "ͻȺ "
   @ 08,02 SAY ""
   @ 08,20 SAY ""
   @ 07,04 SAY "MENU TO .. Demo"
   @ 08,03 SAY ""
   @ 09,03 PROMPT " @ SAY..GET Demo "
   @ 10,03 PROMPT " TBROWSE() Demo  "
   @ 11,03 PROMPT " MEMOEDIT() Demo "
   @ 12,03 PROMPT " ACHOICE() Demo  "
   @ 13,03 PROMPT " INKEY() Demo    "

   MENU TO nMenuItem

   SET COLOR TO N/W
   @ 05,25,24,78 BOX REPLICATE(CHR(178), 9)

   DO CASE
      CASE nMenuItem = 0
           EXIT
      CASE nMenuItem = 1
           GetDemo()
      CASE nMenuItem = 2
           TBrowseDemo()
      CASE nMenuItem = 3
           MemoEditDemo()
      CASE nMenuItem = 4
           AchoiceDemo()
      CASE nMenuItem = 5
           InKeyDemo()
   ENDCASE

   RESTSCREEN(05,23,24,78, cScreen)
ENDDO

SET COLOR TO
@ 00,29 CLEAR TO 03,79
@ 01,40 SAY 'Thank You for Running this Demo.'
@ 02,40 SAY 'We Hope You Liked It.'
@ 04,00 CLEAR TO 24,79
@ 05,00 say ''

SET CURSOR ON

RETURN (NIL)
*| EOF SOS_Demo

*|----------------------------------------------------------------------------|*

FUNCTION GetDemo
**
** Syntax ..... GETDEMO()
**
** Purpose .... Demonstrate an @..SAY..GET with Help
**
** Argument ... None
**
** Returns .... Nothing
**

LOCAL GETLIST := {}, cProduct := 'SOS Help! V1.25   '

SET COLOR TO +W/G
@ 15,25,21,78 BOX "ͻȺ"
@ 21,44 SAY " Commentary Box "
SET COLOR TO N/W
@ 16,26,20,77 BOX "         "
@ 17,28 SAY "This is a simple @..SAY..GET using a variable"
@ 18,28 SAY "called cProduct. We could have used a Field"
@ 19,28 SAY "Name just as easily."

SET COLOR TO +W/W
@ 06,28,12,73 BOX "Ŀ "
@ 08,28 SAY ""
@ 08,73 SAY ""
@ 07,43 SAY "@ .. SAY .. GET Demo"
@ 08,29 SAY ""
@ 10,31 SAY "Enter Product Name: ["
@ 10,70 SAY ']'
@ 10,52 GET cProduct

SET CURSOR ON
READ
SET CURSOR OFF

RETURN (NIL)
*| EOF GetDemo

*|----------------------------------------------------------------------------|*

FUNCTION TBrowseDemo
**
** Syntax ..... TBROWSEDEMO()
**
** Purpose .... Demonstrate TBROWSE with Help
**
** Argument ... None
**
** Returns .... Nothing
**

LOCAL cColor, oCol, oBrowse, nElement := 1

cColor := SETCOLOR('+W/G')
@ 17,25,22,76 BOX "ͻȺ"
@ 22,44 SAY " Commentary Box "
SET COLOR TO N/W
@ 18,26,21,75 BOX "         "
@ 19,28 SAY "This is a TBROWSE() Object containing a list"
@ 20,28 SAY "of all the ASCII values and their Characters."

SET COLOR TO +W/W
@ 05,33,14,70 BOX "Ŀ "
@ 07,33 SAY ""
@ 07,70 SAY ""
@ 06,46 SAY "TBROWSE() Demo"
@ 07,34 SAY ""

set color to
oBrowse := TBROWSENEW(08,35,13,68)

oBrowse:goTopBlock    := {|| nElement := 1 }
oBrowse:goBottomBlock := {|| nElement := LEN(saASCII)}
oBrowse:skipBlock     := {|nMove| Traverse(nMove, saASCII, @nElement)}
oBrowse:colSep        := ''
oBrowse:headSep       := ''

cColor := setcolor()
oBrowse:colorSpec := 'N/W, W/N'

oCol := TBCOLUMNNEW('', {|| saASCII[snTBrowseRow]})
oCol:width := LEN(saASCII[1])

oBrowse:AddColumn(oCol)

SetHelpVars('TBrowseDemo', 'oBrowse')    // set up the internal help variables

PickList(oBrowse)                        // this does the actual work

SetHelpVars('','')                       // clear the internal help variables

SETCOLOR(cColor)

RETURN (NIL)
*| EOF TBrowseDemo

*|----------------------------------------------------------------------------|*

FUNCTION MemoEditDemo
**
** Syntax ..... MEMOEDITDEMO()
**
** Purpose .... Demonstrate MEMOEDIT with Help
**
** Argument ... None
**
** Returns .... Nothing
**

LOCAL cColor

cColor := SETCOLOR('+W/G')
@ 17,25,21,78 BOX "ͻȺ"
@ 21,44 SAY " Commentary Box "
SET COLOR TO N/W
@ 18,26,20,77 BOX "         "
@ 19,28 SAY "This is a simple MEMOEDIT(). Press <ESC> to Exit"

SETCOLOR('+W/W')
@ 06,28,14,74 BOX "Ŀ "
@ 08,28 SAY ""
@ 08,74 SAY ""
@ 07,46 SAY "MEMOEDIT() Demo"
@ 08,29 SAY ""

SETCOLOR('N/W')

SetHelpVars('MemoEditDemo', 'Scratch')  // set up the internal help variables

SET CURSOR ON
MEMOEDIT('This is just a scratch pad note..',09,29,13,73)
SET CURSOR OFF

SetHelpVars('','')                      // clear the internal help variables

SETCOLOR(cColor)

RETURN (NIL)
*| EOF MemoEditDemo

*|----------------------------------------------------------------------------|*

FUNCTION AchoiceDemo
**
** Syntax ..... ACHOICEDEMO()
**
** Purpose .... Demonstrate ACHOICE with Help
**
** Argument ... None
**
** Returns .... Nothing
**

LOCAL cColor, aName := {' Phil de Lisle - CEO and Development Director  ', ;
                        ' Terry Webster - Developer                     ', ;
                        ' Pamela Pernot - Documentation                 ', ;
                        ' Cindy Buteux  - Sales and Marketing           ', ;
                        ' Bob Brewster  - Technical Support and Testing '}

cColor := SETCOLOR('+W/W')
@ 06,28,14,76 BOX "Ŀ "
@ 08,28 SAY ""
@ 08,76 SAY ""
@ 07,47 SAY "ACHOICE() Demo"
@ 08,29 SAY ""

SET COLOR TO +W/G
@ 17,26,23,78 BOX "ͻȺ"
@ 23,45 SAY " Commentary Box "
SET COLOR TO N/W
@ 18,27,22,77 BOX "         "
@ 19,29 SAY "This is an ACHOICE() working on an array of the"
@ 20,29 SAY "Team at Lamaura Development Ltd, each with its"
@ 21,29 SAY "own Individual Help Screen (see SOS_DEMO.PRG)."

SETCOLOR('N/W, W/N')

SetHelpVars('AchoiceDemo', 'aName')  // set up the internal help variables

snAchoiceLen := LEN(aName[1])        // needed in AddHelp()

KEYBOARD '\'                         // force into AddHelp()
ACHOICE(09,29,13,75, aName, .T., "AddHelp")

SetHelpVars('','')                   // clear the internal help variables

SETCOLOR(cColor)

RETURN (NIL)
*| EOF AchoiceDemo

*|----------------------------------------------------------------------------|*

FUNCTION InKeyDemo()
**
** Syntax ..... INKEYDEMO()
**
** Purpose .... Demonstrate the use of SOS_Inkey()
**
** Argument ... None
**
** Returns .... Nothing
**

SET COLOR TO +W/G
@ 12,23,22,78 BOX "ͻȺ"
@ 22,42 SAY " Commentary Box "
SET COLOR TO N/W
@ 13,24,21,77 BOX "         "
@ 14,26 SAY "Normally INKEY() is not a true wait state. This"
@ 15,26 SAY "demo uses SOS_Inkey() which takes help variables"
@ 16,26 SAY "as parameters (see SOS_DEMO.PRG)."
@ 18,26 SAY "We are now in an INKEY() loop waiting for you to"
@ 19,26 SAY "press a key (except <F1>) to exit back to the Main"
@ 20,26 SAY "Menu. Try Pressing <F1> now."

DO WHILE SOS_Inkey('InKeyDemo', 'AnyVar') = 0
ENDDO

RETURN (NIL)
*| EOF InKeyDemo

*|----------------------------------------------------------------------------|*

STATIC FUNCTION Hex(n)
**
**  Syntax ..... HEX(<N>)
**
**  Purpose .... Convert Numeric to Hex
**
**  Argument ... <N> = Number to convert
**
**  Returns .... Character
**

LOCAL cHex, nMant, nRemain

cHex := ''

DO WHILE n > 0
   nMant := INT(n / 16)
   nRemain := n - (16 * nMant)

   cHex := STUFF(cHex, 1,0, IIF(nRemain < 10, STR(nRemain,1), CHR(nRemain+55)))
   n := nMant
ENDDO

RETURN ( IIF(EMPTY(cHex), '0', cHex) )
*| EOF Hex

*|----------------------------------------------------------------------------|*

STATIC FUNCTION Traverse(nMove, aArray, nElement)
**
**  Syntax ..... TRAVERSE(<N1>, <A>, <N2>)
**
**  Purpose .... Skip Through Array (Codeblock UDF)
**
**  Argument ... <N1> = No. of Elements to Skip
**               <A>  = Array to Traverse
**               <N2> = Element No  (BY REFERENCE)
**
**  Returns ....
**

LOCAL nMoved    := 0
LOCAL nLastLine := LEN(aArray)

IF nMove > 0
   IF nElement + nMove > nLastLine
      nMoved := nLastLine - nElement
      nElement := nLastLine
   ELSE
      nMoved := nMove
      nElement += nMove
   ENDIF
ELSE
   IF nElement + nMove < 1
      nMoved := 1 - nElement
      nElement := 1
   ELSE
      nMoved := nMove
      nElement += nMove
   ENDIF
ENDIF

snTBrowseRow := nElement

RETURN (nMoved)
*| EOF Traverse

*|----------------------------------------------------------------------------|*

STATIC FUNCTION PickList(oB)
**
** Syntax ..... PICKLIST(<O>)
**
** Purpose .... Activate TBrowseDemo()
**
** Argument ... <O> = TBrowse Object
**
** Returns .... Nothing
**

LOCAL nKey

DO WHILE .T.
   DO WHILE ! oB:stable
      oB:Stabilize()
   ENDDO

   nKey := SOS_InKey()        //  The Problem Area

   DO CASE
      CASE nKey == K_ESC
           exit

      CASE nKey == K_ENTER
           exit

      CASE nKey == K_DOWN
           oB:Down()

      CASE nKey == K_UP
           oB:Up()

      CASE nKey == K_PGDN
           oB:PageDown()

      CASE nKey == K_PGUP
           oB:PageUp()

      CASE (nKey == K_CTRL_PGUP) .or. (nKey == K_HOME)
           oB:GoTop()

      CASE (nKey == K_CTRL_PGDN) .or. (nKey == K_END)
           oB:GoBottom()
   ENDCASE
ENDDO

RETURN (NIL)
*| EOF PickList

*|----------------------------------------------------------------------------|*

STATIC FUNCTION NthPos(cSubstr, cTarget, nTimes, cReplace)
**
**  Syntax ..... NTHPOS(<C1>, <C2>, <N>[, <C3>])
**
**  Purpose .... Return position of n'th occurrence of <C1> in <C2>
**
**  Argument ... <C1> = Substring
**               <C2> = Target String
**               <N>  = No. of occurrence
**               <C3> = ASCII Character to use as replacement [OPTIONAL]
**
**  Returns .... Numeric
**

IF cReplace = nil
   cReplace := chr(1)
ENDIF

IF nTimes > 1
   cTarget := STRTRAN(cTarget, cSubstr, REPLICATE(cReplace, LEN(cSubstr)), 1, nTimes-1)
ENDIF

return (AT(cSubstr, cTarget))
*| EOF NthPos

*|----------------------------------------------------------------------------|*

#include 'achoice.ch'

FUNCTION AddHelp(nMode, nItem, nRow)
**
** Syntax ..... ADDHELP(<N1>, <N2>, <N3>)
**
** Purpose .... Demonstrate how to Add Context Help for EACH Item in an ACHOICE
**
** Argument ... <N1> = ACHOICE Mode
**              <N2> = No. of Current Item
**              <N3> = Current Row No.
**
** Returns .... Numeric (command for ACHOICE)
**

LOCAL nRetValue, nKey

IF nMode = AC_EXCEPT
   nKey := LASTKEY()
   DO CASE
      CASE nKey = K_ESC
           nRetValue := AC_ABORT
      CASE nKey = K_ENTER
           nRetValue := AC_SELECT
      CASE (nKey >= 32) .AND. (nKey <= 255)
           nRetValue := AC_GOTO
      OTHERWISE
           nRetValue := AC_CONT
   ENDCASE
ELSE
   nRetValue := AC_CONT
ENDIF

IF nRetValue = AC_CONT
   GetItemForHelp(snAchoiceLen)      // identify this item - in ALT_FUNC.PRG
ENDIF


RETURN (nRetValue)
*| EOF AddHelp

*|----------------------------------------------------------------------------|*
