********************
********************
**
**   Source File ... SOS_FUNC.PRG
**
**   Application ... SOS Help! v1.25b
**                   Copyright (c) 1988-1992 Lamaura Development Limited
**                   All Rights Reserved
**
**   Author ........ Philip de Lisle
**   Last Update ... 20 October 1992 at 1:25am
**   Purpose .......
**
********************
********************

*|
*|  Change this portion of the code if you wish to have the help
*|  configured for your own needs.
*|
*|  For example if you have your OWN SYSTEM PARAMETERS instead of
*|  the proc,line,field PARAMETERs passed to help simply RETURN YOUR OWN
*|  PARAMETERS formatted in the same manner as shown.
*|
*|  NOTE :- The existing system does NOT use H_Line()
*|


function H_Name(t_name)
**
** Syntax ..... H_NAME(<C>)
**
** Purpose .... User Defined Help Procedure Names
**
** Argument ... <C> = Help Procedure Name
**
** Returns .... Character
**

return ( left(upper( t_name )+SPACE(10),10) )
*| EOF H_Name

*|----------------------------------------------------------------------------|*

function H_Line(t_line)
**
** Syntax ..... H_LINE(<N>)
**
** Purpose .... User Defined Help Procedure Line Numbers (NOT used by SOS Help!)
**
** Argument ... <N> = Help Procedure Line No.
**
** Returns .... Numeric
**

return (t_line)
*| EOF H_Line

*|----------------------------------------------------------------------------|*

function H_Var(t_var)
**
** Syntax ..... H_VAR(<C>)
**
** Purpose .... User Defined Help Variable Names
**
** Argument ... <C> = Help Variable Name
**
** Returns .... Character
**

return ( left(upper( t_var )+SPACE(10),10) )
*| EOF H_Var

*|----------------------------------------------------------------------------|*

function H_Color(cColor, nID)
**
** Syntax ..... H_COLOR(<C>, <N>)
**
** Purpose .... User Defined Help Variable Names
**
** Argument ... <C> = Help Screen Color in BINARY Model
**              <N> = ID of object to be colored
**
** Returns .... Character
**
** Note ....... H_Color() allows you to set colors for your help screens which
**              are EXTERNAL to the .HLP file.  This UDF is only active in the
**              BINARY model
**

/*  UNCOMMENT THIS SECTION TO ASSIGN EXTERNAL, FIXED COLORS TO YOU HELP SCREENS

#include 'sos_help.ch'    //  contains the manifest constants required
do case
   case nID = BOX_COLOR
        cColor = '+gr/b'
   case nID = SHAD_COLOR
        cColor = 'g/w'
   case nID = TEXT_COLOR
        cColor = '+w/br'
   case nID = TITLE_COLOR
        cColor = '+r/bg'
endcase
*/

return (cColor)
*| EOF H_Color

*|----------------------------------------------------------------------------|*
*|----------------------------------------------------------------------------|*
*|----------------------------------------------------------------------------|*
*|----------------------------------------------------------------------------|*

*|
*|  Change this portion of the code if you wish to use RDD's or configure the
*|  help database handling characteristics.
*|

function SOS_Use(cName)
**
** Syntax ..... SOS_USE(<C>)
**
** Purpose .... Open .DBF with RDD support
**
** Argument ... <C> = .DBF Name
**
** Returns .... Nothing
**
** Note ....... *NEVER* change the ALIAS clauses as these are used internally.
**
**              The SOS Help! help table is *ALWAYS* opened in exclusive mode
**              regardless of the setting of the SET EXCLUSIVE command, unless
**              you have purchased a multi-user version of SOS Help!
**

use (cName) alias SOS_HELP

return (nil)
*| EOF SOS_Use

*|----------------------------------------------------------------------------|*

function SOS_Index(cExp, cIndex)
**
** Syntax ..... SOS_INDEX(<C1>, <C2>)
**
** Purpose .... Index Table to Index File/Tag
**
** Argument ... <C1> = Index Expression
**              <C2> = Index File/Tag Name
**
** Returns .... Nothing
**

index on &cExp to (cIndex)

return (nil)
*| EOF SOS_Index

*|----------------------------------------------------------------------------|*

function SOS_SetIndex(cIndex)
**
** Syntax ..... SOS_INDEX(<C>)
**
** Purpose .... Open Index File
**
** Argument ... <C> = Index File Name
**
** Returns .... Nothing
**

set index to (cIndex)

return (nil)
*| EOF SOS_Index

*|----------------------------------------------------------------------------|*
